summaryrefslogtreecommitdiff
path: root/test
diff options
context:
space:
mode:
authorHarald Hoyer <harald@redhat.com>2009-07-13 16:41:05 +0200
committerHarald Hoyer <harald@redhat.com>2009-07-13 16:41:05 +0200
commit4fafddf78f5b0ef7833157992665d50575b65420 (patch)
tree8cf2f6f31eb9437bcf2850acc82384aa76845ecf /test
parentc81a97d1a7fb1f7ed8960cea49914b900a084a8f (diff)
add test for simple root on LVM
Diffstat (limited to 'test')
-rw-r--r--test/TEST-11-LVM/Makefile10
-rwxr-xr-xtest/TEST-11-LVM/create-root.sh27
-rwxr-xr-xtest/TEST-11-LVM/cryptroot-ask6
-rwxr-xr-xtest/TEST-11-LVM/hard-off.sh2
-rwxr-xr-xtest/TEST-11-LVM/test-init10
-rwxr-xr-xtest/TEST-11-LVM/test.sh76
6 files changed, 131 insertions, 0 deletions
diff --git a/test/TEST-11-LVM/Makefile b/test/TEST-11-LVM/Makefile
new file mode 100644
index 0000000..bc0ddb6
--- /dev/null
+++ b/test/TEST-11-LVM/Makefile
@@ -0,0 +1,10 @@
+all:
+ @make -s --no-print-directory -C ../.. all
+ @basedir=../.. testdir=../ ./test.sh --all
+setup:
+ @make --no-print-directory -C ../.. all
+ @basedir=../.. testdir=../ ./test.sh --setup
+clean:
+ @basedir=../.. testdir=../ ./test.sh --clean
+run:
+ @basedir=../.. testdir=../ ./test.sh --run
diff --git a/test/TEST-11-LVM/create-root.sh b/test/TEST-11-LVM/create-root.sh
new file mode 100755
index 0000000..1c1e92a
--- /dev/null
+++ b/test/TEST-11-LVM/create-root.sh
@@ -0,0 +1,27 @@
+#!/bin/sh
+# don't let udev and this script step on eachother's toes
+for x in 63-luks.rules 64-lvm.rules 70-mdadm.rules 99-mount-rules; do
+ > "/etc/udev/rules.d/$x"
+done
+udevadm control --reload-rules
+# save a partition at the beginning for future flagging purposes
+sfdisk -C 640 -H 2 -S 32 -L /dev/sda <<EOF
+,1
+,213
+,213
+,213
+EOF
+for i in sda2 sda3 sda4; do
+lvm pvcreate -ff -y /dev/$i ;
+done && \
+lvm vgcreate dracut /dev/sda[234] && \
+lvm lvcreate -l 100%FREE -n root dracut && \
+lvm vgchange -ay && \
+mke2fs /dev/dracut/root && \
+mkdir -p /sysroot && \
+mount /dev/dracut/root /sysroot && \
+cp -a -t /sysroot /source/* && \
+umount /sysroot && \
+lvm lvchange -a n /dev/dracut/root && \
+echo "dracut-root-block-created" >/dev/sda1
+poweroff -f
diff --git a/test/TEST-11-LVM/cryptroot-ask b/test/TEST-11-LVM/cryptroot-ask
new file mode 100755
index 0000000..db27c5b
--- /dev/null
+++ b/test/TEST-11-LVM/cryptroot-ask
@@ -0,0 +1,6 @@
+#!/bin/sh
+
+[ -b /dev/mapper/$2 ] && exit 0
+echo -n test >/keyfile
+/sbin/cryptsetup luksOpen $1 $2 </keyfile
+
diff --git a/test/TEST-11-LVM/hard-off.sh b/test/TEST-11-LVM/hard-off.sh
new file mode 100755
index 0000000..85fd849
--- /dev/null
+++ b/test/TEST-11-LVM/hard-off.sh
@@ -0,0 +1,2 @@
+#!/bin/sh
+getarg rdinitdebug || poweroff -f
diff --git a/test/TEST-11-LVM/test-init b/test/TEST-11-LVM/test-init
new file mode 100755
index 0000000..ccdc9a4
--- /dev/null
+++ b/test/TEST-11-LVM/test-init
@@ -0,0 +1,10 @@
+#!/bin/sh
+exec >/dev/console 2>&1
+echo "dracut-root-block-success" >/dev/sda1
+export TERM=linux
+export PS1='initramfs-test:\w\$ '
+[ -f /etc/fstab ] || ln -s /proc/mounts /etc/fstab
+stty sane
+echo "made it to the rootfs! Powering down."
+mount -n -o remount,ro /
+poweroff -f
diff --git a/test/TEST-11-LVM/test.sh b/test/TEST-11-LVM/test.sh
new file mode 100755
index 0000000..19d72aa
--- /dev/null
+++ b/test/TEST-11-LVM/test.sh
@@ -0,0 +1,76 @@
+#!/bin/bash
+TEST_DESCRIPTION="root filesystem on LVM PV"
+
+KVERSION=${KVERSION-$(uname -r)}
+
+# Uncomment this to debug failures
+#DEBUGFAIL="rdinitdebug rdnetdebug"
+
+test_run() {
+ $testdir/run-qemu -hda root.ext2 -m 256M -nographic \
+ -net none -kernel /boot/vmlinuz-$KVERSION \
+ -append "root=/dev/dracut/root rw quiet console=ttyS0,115200n81 rdshell $DEBUGFAIL" \
+ -initrd initramfs.testing
+ grep -m 1 -q dracut-root-block-success root.ext2 || return 1
+}
+
+test_setup() {
+ # Create the blank file to use as a root filesystem
+ dd if=/dev/zero of=root.ext2 bs=1M count=20
+
+ kernel=$KVERSION
+ # Create what will eventually be our root filesystem onto an overlay
+ (
+ initdir=overlay/source
+ . $basedir/dracut-functions
+ dracut_install sh df free ls shutdown poweroff stty cat ps ln ip route \
+ /lib/terminfo/l/linux mount dmesg ifconfig dhclient mkdir cp ping dhclient
+ inst "$basedir/modules.d/40network/dhclient-script" "/sbin/dhclient-script"
+ inst "$basedir/modules.d/40network/ifup" "/sbin/ifup"
+ dracut_install grep
+ inst ./test-init /sbin/init
+ find_binary plymouth >/dev/null && dracut_install plymouth
+ (cd "$initdir"; mkdir -p dev sys proc etc var/run tmp )
+ )
+
+ # second, install the files needed to make the root filesystem
+ (
+ initdir=overlay
+ . $basedir/dracut-functions
+ dracut_install sfdisk mke2fs poweroff cp umount
+ inst_simple ./create-root.sh /initqueue/01create-root.sh
+ )
+
+ # create an initramfs that will create the target root filesystem.
+ # We do it this way so that we do not risk trashing the host mdraid
+ # devices, volume groups, encrypted partitions, etc.
+ $basedir/dracut -l -i overlay / \
+ -m "dash lvm mdraid udev-rules base rootfs-block kernel-modules" \
+ -d "ata_piix ext2 sd_mod" \
+ -f initramfs.makeroot $KVERSION || return 1
+ rm -rf overlay
+ # Invoke KVM and/or QEMU to actually create the target filesystem.
+ $testdir/run-qemu -hda root.ext2 -m 256M -nographic -net none \
+ -kernel "/boot/vmlinuz-$kernel" \
+ -append "root=/dev/dracut/root rw rootfstype=ext2 quiet console=ttyS0,115200n81" \
+ -initrd initramfs.makeroot || return 1
+ grep -m 1 -q dracut-root-block-created root.ext2 || return 1
+ (
+ initdir=overlay
+ . $basedir/dracut-functions
+ dracut_install poweroff shutdown
+ inst_simple ./hard-off.sh /emergency/01hard-off.sh
+ )
+ sudo $basedir/dracut -l -i overlay / \
+ -o "plymouth" \
+ -a "debug" \
+ -d "ata_piix ext2 sd_mod" \
+ -f initramfs.testing $KVERSION || return 1
+}
+
+test_cleanup() {
+ rm -fr overlay mnt
+ rm -f root.ext2 initramfs.makeroot initramfs.testing
+}
+
+. $testdir/test-functions